import Vue from 'vue'
import Button from './button'
import Icon from './icon'
import ButtonGroup from './button-group'

Vue.component('h-button',Button)
Vue.component('h-icon',Icon)
Vue.component('h-button-group',ButtonGroup)
new Vue({
  el:"#app",
  data:{ 
      loading1:true,
      loading2:false,
      loading3:false,
  }
})

// //单元测试
// import chai from'chai'
// import spies from'chai-spies'
// chai.use(spies)
// const expect=chai.expect
// try{
//   {
//     // icon
//     const Constructor=Vue.extend(Button)
//     const vm=new Constructor({
//       propsData:{
//         icon:'setting'
//       }
//     })
    
//     vm.$mount()
//     let useElement=vm.$el.querySelector('use')
//     let href=useElement.getAttribute('xlink:href')
//     expect(href).to.eq('#i-setting')
//   }
//   {
//     // loading
//     const Constructor=Vue.extend(Button)
//     const vm=new Constructor({
//       propsData:{
//         icon:'setting',
//         loading:true
//       }
//     })
//     vm.$mount()
//     let useElement=vm.$el.querySelector('use')
//     let href=useElement.getAttribute('xlink:href')
//     expect(href).to.eq('#i-loading')
//   }
//   {
//     //icon left
//     const div=document.createElement('div')
//     document.body.appendChild(div)
//     const Constructor=Vue.extend(Button)
//     const vm=new Constructor({
//       propsData:{
//         icon:'setting'
//       }
//     })
//     vm.$mount(div)
//     let svg=vm.$el.querySelector('svg')
//     let {order}=window.getComputedStyle(svg)
//     expect(order).to.eq('1')
//     vm.$el.remove()
//     vm.$destroy()
//   }
//   {
//     //icon right
//     const div=document.createElement('div')
//     document.body.appendChild(div)
//     const Constructor=Vue.extend(Button)
//     const vm=new Constructor({
//       propsData:{
//         icon:'setting',
//         iconPosition:'right'
//       }
//     })
//     vm.$mount(div)
//     let svg=vm.$el.querySelector('svg')
//     let {order}=window.getComputedStyle(svg)
//     expect(order).to.eq('2')
//     vm.$el.remove()
//     vm.$destroy()
//   }
//   {
//     //函数的mock
//     const Constructor=Vue.extend(Button)
//     const vm=new Constructor({
//       propsData:{
//         icon:'setting'
//       }
//     })
//     vm.$mount()
//     let spy=chai.spy(()=>{
//     })
//     vm.$on('click',spy)
//     let button=vm.$el
//     button.click()
//     expect(spy).to.have.been.called()
//   }
// }catch(error){
//   window.errors=[error]
// }finally{
//   window.errors&&window.errors.forEach((error)=>{
//     console.error(error.message)
//   })
// }